Index: trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelectorDialog.Designer.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelectorDialog.Designer.cs	(revision 15682)
+++ trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelectorDialog.Designer.cs	(revision 16117)
@@ -45,9 +45,12 @@
     /// </summary>
     private void InitializeComponent() {
-      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(HiveResourceSelectorDialog));
+      this.components = new System.ComponentModel.Container();
       this.okButton = new System.Windows.Forms.Button();
       this.cancelButton = new System.Windows.Forms.Button();
       this.refreshButton = new System.Windows.Forms.Button();
-      this.hiveResourceSelector = new HeuristicLab.Clients.Hive.JobManager.Views.HiveResourceSelector();
+      this.toolTip = new System.Windows.Forms.ToolTip(this.components);
+      this.errorProvider = new System.Windows.Forms.ErrorProvider(this.components);
+      this.hiveResourceSelector = new HeuristicLab.Clients.Hive.JobManager.Views.HiveProjectSelector();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
       this.SuspendLayout();
       // 
@@ -56,4 +59,5 @@
       this.okButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
       this.okButton.DialogResult = System.Windows.Forms.DialogResult.OK;
+      this.okButton.Enabled = false;
       this.okButton.Location = new System.Drawing.Point(405, 609);
       this.okButton.Name = "okButton";
@@ -62,4 +66,6 @@
       this.okButton.Text = "&OK";
       this.okButton.UseVisualStyleBackColor = true;
+      this.errorProvider.SetIconAlignment(this.okButton, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
+      this.errorProvider.SetIconPadding(this.okButton, 2);
       // 
       // cancelButton
@@ -82,24 +88,37 @@
       this.refreshButton.Size = new System.Drawing.Size(24, 24);
       this.refreshButton.TabIndex = 3;
+      this.toolTip.SetToolTip(this.refreshButton, "Refresh data");
       this.refreshButton.UseVisualStyleBackColor = true;
       this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
       // 
+      // errorProvider
+      // 
+      this.errorProvider.BlinkStyle = System.Windows.Forms.ErrorBlinkStyle.NeverBlink;
+      this.errorProvider.ContainerControl = this;
+      // 
       // hiveResourceSelector
       // 
-      this.hiveResourceSelector.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
+      this.hiveResourceSelector.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
+            | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.hiveResourceSelector.Caption = "View";
       this.hiveResourceSelector.Content = null;
+      this.hiveResourceSelector.JobId = new System.Guid("00000000-0000-0000-0000-000000000000");
       this.hiveResourceSelector.Location = new System.Drawing.Point(12, 12);
       this.hiveResourceSelector.Name = "hiveResourceSelector";
+      this.hiveResourceSelector.ProjectId = null;
       this.hiveResourceSelector.ReadOnly = false;
+      this.hiveResourceSelector.SelectedProject = null;
+      this.hiveResourceSelector.SelectedProjectId = null;
+      this.hiveResourceSelector.SelectedResourceIds = null;
       this.hiveResourceSelector.Size = new System.Drawing.Size(549, 591);
       this.hiveResourceSelector.TabIndex = 0;
+      this.hiveResourceSelector.SelectedProjectChanged += new System.EventHandler(this.hiveResourceSelector_SelectedProjectChanged);
+      this.hiveResourceSelector.AssignedResourcesChanged += new System.EventHandler(this.hiveResourceSelector_SelectedResourcesChanged);
+      this.hiveResourceSelector.ProjectsTreeViewDoubleClicked += new System.EventHandler(this.hiveResourceSelector_ProjectsTreeViewDoubleClicked);
       // 
       // HiveResourceSelectorDialog
       // 
       this.AcceptButton = this.okButton;
-      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
       this.CancelButton = this.cancelButton;
@@ -115,7 +134,7 @@
       this.ShowInTaskbar = false;
       this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
-      this.Text = "Select Resources";
-      this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.HiveResourceSelectorDialog_FormClosing);
+      this.Text = "Select Project";
       this.Load += new System.EventHandler(this.HiveResourceSelectorDialog_Load);
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
       this.ResumeLayout(false);
 
@@ -126,6 +145,8 @@
     protected System.Windows.Forms.Button okButton;
     protected System.Windows.Forms.Button cancelButton;
-    protected HiveResourceSelector hiveResourceSelector;
     protected System.Windows.Forms.Button refreshButton;
+    protected System.Windows.Forms.ToolTip toolTip;
+    protected System.Windows.Forms.ErrorProvider errorProvider;
+    protected HiveProjectSelector hiveResourceSelector;
   }
 }
Index: trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelectorDialog.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelectorDialog.cs	(revision 15682)
+++ trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/HiveResourceSelectorDialog.cs	(revision 16117)
@@ -20,47 +20,161 @@
 #endregion
 
+using System;
 using System.Collections.Generic;
-using System.Threading.Tasks;
+using System.ComponentModel;
+using System.Linq;
 using System.Windows.Forms;
-using HeuristicLab.PluginInfrastructure;
+using HeuristicLab.Clients.Hive.Views;
+using HeuristicLab.MainForm;
+using HeuristicLab.Core;
 
 namespace HeuristicLab.Clients.Hive.JobManager.Views {
   public partial class HiveResourceSelectorDialog : Form {
-    public HiveResourceSelectorDialog() {
+    private readonly object locker = new object();
+    private bool updatingProjects = false;
+
+    public Project SelectedProject {
+      get { return hiveResourceSelector.SelectedProject; }
+    }
+
+    public IEnumerable<Resource> SelectedResources {
+      get { return hiveResourceSelector.AssignedResources; }
+    }
+
+    private Guid jobId;
+    public Guid JobId {
+      get { return hiveResourceSelector.JobId; }
+      set { jobId = value; }
+    }
+
+    // persisted projectId
+    private Guid? projectId;
+    public Guid? ProjectId {
+      get { return hiveResourceSelector.ProjectId; }
+      set { projectId = value; }
+    }
+
+    // currently selected projectId (initially the persisted projectId)
+    private Guid? selectedProjectId;
+    public Guid? SelectedProjectId {
+      get { return selectedProjectId; }
+      set { selectedProjectId = value; }
+    }
+
+    // currently selected resourceIds (if null, perform lookup in HiveResourceSelector)
+    private IEnumerable<Guid> selectedResourceIds;
+    public IEnumerable<Guid> SelectedResourceIds {
+      get { return selectedResourceIds; }
+      set { selectedResourceIds = value; }
+    }
+
+
+
+    public HiveResourceSelectorDialog(Guid jobId, Guid projectId) {
+      this.jobId = jobId;
+      this.projectId = projectId;
+      this.selectedProjectId = projectId;
       InitializeComponent();
     }
 
-    public ISet<Resource> GetSelectedResources() { return hiveResourceSelector.SelectedResources; }
-
-    private void HiveResourceSelectorDialog_Load(object sender, System.EventArgs e) {
-      HiveAdminClient.Instance.Refreshed += new System.EventHandler(Instance_Refreshed);
-      DownloadResources();
+    #region Overrides
+    protected override void OnLoad(EventArgs e) {
+      HiveClient.Instance.Refreshing += HiveClient_Instance_Refreshing;
+      HiveClient.Instance.Refreshed += HiveClient_Instance_Refreshed;
+      base.OnLoad(e);
     }
 
-    private void HiveResourceSelectorDialog_FormClosing(object sender, FormClosingEventArgs e) {
-      HiveAdminClient.Instance.Refreshed -= new System.EventHandler(Instance_Refreshed);
+    protected override void OnClosing(CancelEventArgs e) {
+      HiveClient.Instance.Refreshed -= HiveClient_Instance_Refreshed;
+      HiveClient.Instance.Refreshing -= HiveClient_Instance_Refreshing;
+      base.OnClosing(e);
+    }
+    #endregion
+
+    #region Event Handlers
+    private void HiveClient_Instance_Refreshing(object sender, EventArgs e) {
+      if (InvokeRequired) Invoke((Action<object, EventArgs>)HiveClient_Instance_Refreshing, sender, e);
+      else {
+        var mainForm = MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>();
+        mainForm.AddOperationProgressToView(this, "Refreshing ...");
+        refreshButton.Enabled = false;
+      }
     }
 
-    void Instance_Refreshed(object sender, System.EventArgs e) {
-      hiveResourceSelector.Content = HiveAdminClient.Instance.Resources;
+    private void HiveClient_Instance_Refreshed(object sender, EventArgs e) {
+      if (InvokeRequired) Invoke((Action<object, EventArgs>)HiveClient_Instance_Refreshed, sender, e);
+      else {
+        var mainForm = MainFormManager.GetMainForm<MainForm.WindowsForms.MainForm>();
+        mainForm.RemoveOperationProgressFromView(this);
+        refreshButton.Enabled = true;
+      }
     }
 
-    private void refreshButton_Click(object sender, System.EventArgs e) {
-      DownloadResources();
+    private async void HiveResourceSelectorDialog_Load(object sender, EventArgs e) {
+      lock (locker) {
+        if (updatingProjects) return;
+        updatingProjects = true;
+      }
+
+      await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
+        action: () => UpdateProjects(),
+        finallyCallback: () => updatingProjects = false);
     }
 
-    private void DownloadResources() {
-      var task = System.Threading.Tasks.Task.Factory.StartNew(DownloadResourcesAsync);
-      task.ContinueWith(t => {
-        hiveResourceSelector.FinishProgressView();
-        ErrorHandling.ShowErrorDialog(this, "An error occurred while downloading the tasks.", t.Exception);
-      }, TaskContinuationOptions.OnlyOnFaulted);
+    private async void refreshButton_Click(object sender, EventArgs e) {
+      lock (locker) {
+        if (updatingProjects) return;
+        updatingProjects = true;
+      }
+
+      await SecurityExceptionUtil.TryAsyncAndReportSecurityExceptions(
+        action: () => UpdateProjects(),
+        finallyCallback: () => updatingProjects = false);
     }
 
-    private void DownloadResourcesAsync() {
-      hiveResourceSelector.StartProgressView();
-      HiveAdminClient.Instance.Refresh();
-      hiveResourceSelector.FinishProgressView();
+    private void hiveResourceSelector_SelectedProjectChanged(object sender, EventArgs e) {
+      okButton.Enabled = hiveResourceSelector.SelectedProject != null && hiveResourceSelector.AssignedResources.Any();
     }
+
+    private void hiveResourceSelector_SelectedResourcesChanged(object sender, EventArgs e) {
+      okButton.Enabled = hiveResourceSelector.AssignedResources.Any();
+
+      if(!hiveResourceSelector.AssignedResources.Any()) {
+        errorProvider.SetError(okButton, "Note: currently no resources are assigned");
+      } else if(hiveResourceSelector.AssignedCores == 0) {
+        errorProvider.SetError(okButton, "Note: currently no resources with cores are assigned");
+      } else {
+        errorProvider.SetError(okButton, string.Empty);
+      }
+    }
+
+    private void hiveResourceSelector_ProjectsTreeViewDoubleClicked(object sender, EventArgs e) {
+      if (hiveResourceSelector.SelectedProject == null) return;
+      if (!hiveResourceSelector.AssignedResources.Any()) return;
+
+      DialogResult = DialogResult.OK;
+      Close();
+    }
+    #endregion
+
+    #region Helpers
+    private void UpdateProjects() {
+      HiveClient.Instance.RefreshProjectsAndResources();
+      hiveResourceSelector.JobId = jobId;
+      hiveResourceSelector.ProjectId = projectId;
+      hiveResourceSelector.SelectedProjectId = selectedProjectId;
+      hiveResourceSelector.SelectedResourceIds = selectedResourceIds;
+      hiveResourceSelector.Content = HiveClient.Instance.Projects;
+    }
+
+    private void ShowHiveInformationDialog() {
+      if (InvokeRequired) Invoke((Action)ShowHiveInformationDialog);
+      else {
+        using (HiveInformationDialog dialog = new HiveInformationDialog()) {
+          dialog.ShowDialog(this);
+        }
+      }
+    }
+    #endregion
   }
 }
Index: trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobListView.cs
===================================================================
--- trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobListView.cs	(revision 15682)
+++ trunk/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobListView.cs	(revision 16117)
@@ -41,17 +41,27 @@
       this.itemsListView.Columns.Add(new ColumnHeader("Date") { Text = "Date" });
       this.itemsListView.Columns.Add(new ColumnHeader("Name") { Text = "Name" });
+      this.itemsListView.Columns.Add(new ColumnHeader("Project") { Text = "Project" });
 
       this.itemsListView.HeaderStyle = ColumnHeaderStyle.Clickable;
       this.itemsListView.FullRowSelect = true;
 
-      this.itemsListView.ListViewItemSorter = new ListViewItemDateComparer(0, SortOrder.Ascending);
+      this.itemsListView.ListViewItemSorter = new ListViewItemComparer(new int[] { 2, 0 }, new SortOrder[] { SortOrder.Ascending, SortOrder.Ascending });
+
+      foreach (ColumnHeader c in this.itemsListView.Columns) {
+        c.AutoResize(ColumnHeaderAutoResizeStyle.HeaderSize);
+        int w = c.Width;
+        c.AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+        if(w > c.Width) {
+          c.AutoResize(ColumnHeaderAutoResizeStyle.HeaderSize);
+        }
+      }
     }
 
     protected override void SortItemsListView(SortOrder sortOrder) {
       if (itemsListView.Sorting == sortOrder || sortOrder == SortOrder.None) return;
-      ((ListViewItemDateComparer)itemsListView.ListViewItemSorter).Order = sortOrder;
+      ((ListViewItemComparer)itemsListView.ListViewItemSorter).Orders[1] = sortOrder;
       itemsListView.Sorting = sortOrder;
       itemsListView.Sort();
-      AdjustListViewColumnSizes();
+      //AdjustListViewColumnSizes();
     }
 
@@ -133,5 +143,10 @@
         base.Content_ItemsAdded(sender, e);
         foreach (ColumnHeader c in this.itemsListView.Columns) {
+          c.AutoResize(ColumnHeaderAutoResizeStyle.HeaderSize);
+          int w = c.Width;
           c.AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent);
+          if (w > c.Width) {
+            c.AutoResize(ColumnHeaderAutoResizeStyle.HeaderSize);
+          }
         }
         foreach (var item in e.Items) {
@@ -180,4 +195,6 @@
       listViewItem.SubItems.Insert(0, new ListViewItem.ListViewSubItem(listViewItem, item.Job.DateCreated.ToString()));
       listViewItem.SubItems.Insert(1, new ListViewItem.ListViewSubItem(listViewItem, item.Job.Name));
+      listViewItem.SubItems.Insert(2, new ListViewItem.ListViewSubItem(listViewItem, HiveClient.Instance.GetProjectAncestry(item.Job.ProjectId)));
+      
       listViewItem.Group = GetListViewGroup(item.Job.OwnerUsername);
       return listViewItem;
@@ -189,4 +206,5 @@
       listViewItem.SubItems[0].Text = item == null ? "null" : item.Job.DateCreated.ToString("dd.MM.yyyy HH:mm");
       listViewItem.SubItems[1].Text = item == null ? "null" : item.Job.Name;
+      listViewItem.SubItems[2].Text = item == null ? "null" : HiveClient.Instance.GetProjectAncestry(item.Job.ProjectId);
       listViewItem.Group = GetListViewGroup(item.Job.OwnerUsername);
       listViewItem.ToolTipText = item == null ? string.Empty : item.ItemName + ": " + item.ItemDescription;
